Get a list of Environments
GET /api
Also reachable at /api, /api.
Lists all of the environments in the supplied Octopus Deploy Space. The results will be sorted by the SortOrder field on each environment.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
idsarray of string
Environment Ids to filter results to only Environments with the given Ids.namestring
Filters the returned environments by the specifiednamefragment. Left for backwards compatibility; prefer PartialName.partialNamestring
Filters the documents using the specifiedpartialNamefragment.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 10. Minimum0.
Response
200 — The requested list of Environments
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectAllowDynamicInfrastructureboolean
If set to true, deployments to this environment will be allowed to contain steps that manage infrastructure. This relies on DeploymentActionResource being set to allow managing resource for a step.Descriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.ExtensionSettingsarray of objectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this environment in sort order. Environments with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringUseGuidedFailureboolean
If set to true, deployments will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Create a new environment
POST /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Request Body
AllowDynamicInfrastructurebooleanDescriptionstringEnvironmentTagsarray of stringExtensionSettingsarray of objectExtensionIdstringValuesstring
Namestring (required)
Minimum length 1. Maximum length 50.SlugstringSortOrderintegerSpaceIdstring (required)UseGuidedFailureboolean
Response
201 — Created
AllowDynamicInfrastructureboolean
If set to true, deployments to this environment will be allowed to contain steps that manage infrastructure. This relies on DeploymentActionResource being set to allow managing resource for a step.Descriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.ExtensionSettingsarray of objectExtensionIdstringValuesstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this environment in sort order. Environments with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringUseGuidedFailureboolean
If set to true, deployments will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Request
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}Example Response
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}Get a list of Environments
GET /api
Also reachable at /api, /api.
Lists the name and ID of all of the environments in the supplied Space. The results will be sorted by the SortOrder field on each environment.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
channelIdstring
A Channel Id used to filter a query.idsarray of string
A comma separated list of Deployment Environment resource ids used to filter a query.projectIdstring
A project Id used to filter a query.
Response
200 — Requested list of Environments
AllowDynamicInfrastructureboolean
If set to true, deployments to this environment will be allowed to contain steps that manage infrastructure. This relies on DeploymentActionResource being set to allow managing resource for a step.Descriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.ExtensionSettingsarray of objectExtensionIdstringValuesstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this environment in sort order. Environments with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringUseGuidedFailureboolean
If set to true, deployments will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Response
[
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}
]Get a list of Environments
GET /api
Also reachable at /api, /api.
Lists the name and ID of all of the environments in the supplied Space. The results will be sorted by the SortOrder field on each environment.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
channelIdstring
A Channel Id used to filter a query.idsarray of string
A comma separated list of Deployment Environment resource ids used to filter a query.projectIdstring
A project Id used to filter a query.
Response
200 — Requested list of Environments
Environmentsarray of objectAllowDynamicInfrastructureboolean
If set to true, deployments to this environment will be allowed to contain steps that manage infrastructure. This relies on DeploymentActionResource being set to allow managing resource for a step.Descriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.ExtensionSettingsarray of objectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this environment in sort order. Environments with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringUseGuidedFailureboolean
If set to true, deployments will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Response
{
"Environments": [
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}
]
}PUT /api/{spaceId}/environments/sortorder
PUT /api
Also reachable at /api, /api.
Takes an array of environment IDs as the request body, uses the order of items in the array to sort the environments on the server. The ID of every environment must be specified.
Path Parameters
spaceIdstring (required)
Request Body
A array of string payload.
Response
200 — Success
Example Request
[
"string"
]List all environments, including a summary of machine information
GET /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Query Parameters
commStylesarray of stringdeploymentTargetTypesarray of stringenvironmentTagsarray of stringhealthStatusesarray of stringhideEmptyEnvironmentsbooleanidsarray of stringisDisabledbooleanmachinePartialNamestringpartialNamestringrolesarray of stringshellNamesarray of stringtargetTagsarray of stringtenantIdsarray of stringtenantTagsarray of string
Response
200 — Contains the machines et al associated with a given environment.
DeploymentTargetSummariesobjectEnvironmentSummariesarray of objectDeploymentTargetSummariesobjectEnvironmentobjectMachineEndpointSummariesobjectMachineHealthStatusSummariesobjectMachineIdsForCalamariUpgradearray of stringMachineIdsForTentacleUpgradearray of stringMachineTenantSummariesobjectMachineTenantTagSummariesobjectTentacleUpgradesRequiredbooleanTotalDisabledMachinesintegerTotalMachinesinteger
MachineEndpointSummariesobjectMachineHealthStatusSummariesobjectMachineIdsForCalamariUpgradearray of stringMachineIdsForTentacleUpgradearray of stringMachineTenantSummariesobjectMachineTenantTagSummariesobjectTentacleUpgradesRequiredbooleanTotalDisabledMachinesintegerTotalMachinesinteger
Example Response
{
"DeploymentTargetSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"EnvironmentSummaries": [
{
"DeploymentTargetSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"Environment": {
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
},
"MachineEndpointSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineHealthStatusSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineIdsForCalamariUpgrade": [
"string"
],
"MachineIdsForTentacleUpgrade": [
"string"
],
"MachineTenantSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineTenantTagSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"TentacleUpgradesRequired": true,
"TotalDisabledMachines": 0,
"TotalMachines": 0
}
],
"MachineEndpointSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineHealthStatusSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineIdsForCalamariUpgrade": [
"string"
],
"MachineIdsForTentacleUpgrade": [
"string"
],
"MachineTenantSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineTenantTagSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"TentacleUpgradesRequired": true,
"TotalDisabledMachines": 0,
"TotalMachines": 0
}List all environments, including a summary of machine information
GET /api
Also reachable at /api.
Path Parameters
spaceIdstring (required)
Query Parameters
commStylesarray of stringdeploymentTargetTypesarray of stringenvironmentTagsarray of stringhealthStatusesarray of stringhideEmptyEnvironmentsbooleanidsarray of stringisDisabledbooleanmachinePartialNamestringpartialNamestringrolesarray of stringshellNamesarray of stringtargetTagsarray of stringtenantIdsarray of stringtenantTagsarray of stringtypearray of string
Filters the environment summaries using the specified environment EnvironmentType.
Response
200 — Contains the machines et al associated with a given environment.
DeploymentTargetSummariesobjectEnvironmentSummariesarray of objectDeploymentTargetSummariesobjectEnvironmentobjectMachineEndpointSummariesobjectMachineHealthStatusSummariesobjectMachineIdsForCalamariUpgradearray of stringMachineIdsForTentacleUpgradearray of stringMachineTenantSummariesobjectMachineTenantTagSummariesobjectTentacleUpgradesRequiredbooleanTotalDisabledMachinesintegerTotalMachinesinteger
MachineEndpointSummariesobjectMachineHealthStatusSummariesobjectMachineIdsForCalamariUpgradearray of stringMachineTenantSummariesobjectMachineTenantTagSummariesobjectTentacleUpgradesRequiredbooleanTotalDisabledMachinesintegerTotalMachinesinteger
Example Response
{
"DeploymentTargetSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"EnvironmentSummaries": [
{
"DeploymentTargetSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"Environment": {
"Description": "string",
"EnvironmentTags": [
"string"
],
"Id": "Environments-1",
"Name": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Type": "string"
},
"MachineEndpointSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineHealthStatusSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineIdsForCalamariUpgrade": [
"string"
],
"MachineIdsForTentacleUpgrade": [
"string"
],
"MachineTenantSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineTenantTagSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"TentacleUpgradesRequired": true,
"TotalDisabledMachines": 0,
"TotalMachines": 0
}
],
"MachineEndpointSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineHealthStatusSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineIdsForCalamariUpgrade": [
"string"
],
"MachineTenantSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineTenantTagSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"TentacleUpgradesRequired": true,
"TotalDisabledMachines": 0,
"TotalMachines": 0
}Get a list of Environments
GET /api
Also reachable at /api, /api.
Lists all of the environments in the supplied Octopus Deploy Space. The results will be sorted by the SortOrder field on each environment.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
idsarray of string
Environment Ids to filter results to only Environments with the given Ids.namestring
Filters the returned environments by the specifiednamefragment. Left for backwards compatibility; prefer PartialName.partialNamestring
Filters the documents using the specifiedpartialNamefragment.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 10. Minimum0.
Response
200 — The requested list of Environments
EnvironmentsobjectIdstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Environments": {
"Id": "string",
"ItemType": "string",
"Items": [
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}
}List Static, Parent and Ephemeral Environments in the supplied Octopus Deploy Space. The results will be sorted by the SortOrder field on each environment (which is set to a MaxValue integer for Ephemeral Environments)
GET /api
Also reachable at /api.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
idsarray of string
Filter environments using ids.namestring
The exact name of an Environment to be matched.partialNamestring
Filters the documents using the specifiedpartialNamefragment.skipinteger (required)
Number of items to skip. Defaults to zero. Minimum0.takeinteger (required)
Number of items to skip. Defaults to zero. Minimum0.typearray of string
Filters the documents using the specified environment EnvironmentType.
Response
200 — Success
ItemTypestringItemsarray of objectDescriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.IdstringNamestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters. Minimum length 1.Slugstring
Minimum length 1.SpaceIdstringTypestring
ItemsPerPageintegerLastPageNumberintegerNumberOfPagesintegerTotalResultsinteger
Example Response
{
"ItemType": "string",
"Items": [
{
"Description": "string",
"EnvironmentTags": [
"string"
],
"Id": "Environments-1",
"Name": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Type": "string"
}
],
"ItemsPerPage": 0,
"LastPageNumber": 0,
"NumberOfPages": 0,
"TotalResults": 0
}Modify an existing environment
PUT /api
Also reachable at /api, /api.
Path Parameters
environmentIdstring (required)spaceIdstring (required)
Request Body
AllowDynamicInfrastructurebooleanDescriptionstringEnvironmentIdstring (required)EnvironmentTagsarray of stringExtensionSettingsarray of objectExtensionIdstringValuesstring
Namestring (required)
Minimum length 1. Maximum length 50.SlugstringSortOrderintegerSpaceIdstring (required)UseGuidedFailureboolean
Response
200 — The environment after modifications have been applied.
AllowDynamicInfrastructureboolean
If set to true, deployments to this environment will be allowed to contain steps that manage infrastructure. This relies on DeploymentActionResource being set to allow managing resource for a step.Descriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.ExtensionSettingsarray of objectExtensionIdstringValuesstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this environment in sort order. Environments with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringUseGuidedFailureboolean
If set to true, deployments will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Request
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentId": "Environments-1",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}Example Response
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}Get the environment custom settings metadata from the extensions
GET /api
Also reachable at /api, /api.
Path Parameters
environmentIdstring (required)
The Id of the environment for which metadata is to be retrieved.spaceIdstring (required)
The Id of the space containing the environment.
Response
200 — The requested Environment Metadata
ExtensionIdstringMetadataobjectDescriptionstringTypesarray of object
Example Response
[
{
"ExtensionId": "string",
"Metadata": {
"Description": "string",
"Types": [
{}
]
}
}
]List all the variable set names (projects and library variable sets) that have variables that are scoped to only the given environment
GET /api
Also reachable at /api, /api.
Path Parameters
environmentIdstring (required)spaceIdstring (required)
Response
200 — The names of LibraryVariableSets and VariableSets which contain one or more variables scoped to the requested environment. Along with boolean indication to show that there are unviewable/editable projects/libraries which also contain scoped variables.
HasUnauthorizedLibraryVariableSetVariablesbooleanHasUnauthorizedProjectVariablesbooleanVariableMapobject
Example Response
{
"HasUnauthorizedLibraryVariableSetVariables": true,
"HasUnauthorizedProjectVariables": true,
"VariableMap": {
"additionalProp1": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"additionalProp2": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"additionalProp3": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
}
}
}Get a specific Deployment Environment
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the Environment to load.spaceIdstring (required)
Response
200 — The requested Deployment Environment
AllowDynamicInfrastructureboolean
If set to true, deployments to this environment will be allowed to contain steps that manage infrastructure. This relies on DeploymentActionResource being set to allow managing resource for a step.Descriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.ExtensionSettingsarray of objectExtensionIdstringValuesstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this environment in sort order. Environments with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringUseGuidedFailureboolean
If set to true, deployments will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Response
{
"AllowDynamicInfrastructure": true,
"Description": "string",
"EnvironmentTags": [
"string"
],
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "Spaces-1",
"UseGuidedFailure": true
}Delete an existing Environment
DELETE /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the Environment to delete.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Success
Return the list of machines in an environment that matches the filters requested by the user
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the Environment.spaceIdstring (required)
ID of the space.
Query Parameters
commStylesarray of stringdeploymentTargetTypesarray of stringhealthStatusesarray of stringisDisabledbooleanpartialNamestringrolesarray of stringshellNamesarray of stringskipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items per page. Defaults to 20. Minimum0.targetTagsarray of stringtenantIdsarray of stringtenantTagsarray of string
Response
200 — The lists of all machines that belong to the given environment, and matches any specified filters.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectArchitecturestringEndpointobjectEnvironmentIdsarray of stringHasLatestCalamaribooleanHealthStatusenum
Allowed values:Healthy,Unavailable,Unknown,HasWarnings,Unhealthy.Idstring
Gets or sets a unique identifier for this resource.IsDisabledbooleanIsInProcessbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.MachinePolicyIdstringNamestringOperatingSystemstringOperatingSystemVersionstringRolesarray of stringShellNamestringShellVersionstringSkipInitialHealthCheckbooleanSlugstringSpaceIdstringStatusSummarystringTenantIdsarray of stringTenantTagsarray of stringTenantedDeploymentParticipationenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.ThumbprintstringUristring
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"Architecture": "string",
"Endpoint": {
"CommunicationStyle": "None",
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {}
},
"EnvironmentIds": [
"Environments-1",
"..."
],
"HasLatestCalamari": true,
"HealthStatus": "Healthy",
"Id": "string",
"IsDisabled": true,
"IsInProcess": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"MachinePolicyId": "string",
"Name": "string",
"OperatingSystem": "string",
"OperatingSystemVersion": "string",
"Roles": [
"string"
],
"ShellName": "string",
"ShellVersion": "string",
"SkipInitialHealthCheck": true,
"Slug": "string",
"SpaceId": "Spaces-1",
"StatusSummary": "string",
"TenantIds": [
"Tenants-1",
"..."
],
"TenantTags": [
"string"
],
"TenantedDeploymentParticipation": "Untenanted",
"Thumbprint": "string",
"Uri": "string"
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Get a specific Static, Parent or Ephemeral Environment by ID
GET /api
Also reachable at /api.
Path Parameters
idstring (required)
ID of the Environment to load.spaceIdstring (required)
The ID of the space containing the resource.
Response
200 — The requested Static, Parent or Ephemeral Environment
Descriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.IdstringNamestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters. Minimum length 1.Slugstring
Minimum length 1.SpaceIdstringTypestring
Example Response
{
"Description": "string",
"EnvironmentTags": [
"string"
],
"Id": "Environments-1",
"Name": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Type": "string"
}List environments available for a project
GET /api
Also reachable at /api.
Path Parameters
projectIdstring (required)
The ID of the project.spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
partialNamestring
Filters the environments by partial name fragment.skipinteger (required)
Number of items to skip. Defaults to zero. Minimum0.takeinteger (required)
Number of items to take. Defaults to 30. Minimum0.typearray of string
Filters the environments by EnvironmentType.
Response
200 — Success
ItemTypestringItemsarray of objectDescriptionstring
Gets or sets a short description of this environment that can be used to explain the purpose of the environment to other users. This field may contain markdown.EnvironmentTagsarray of string
List of tags assigned to this environment.IdstringNamestring
Gets or sets the name of this environment. This should be short, preferably 5-20 characters. Minimum length 1.Slugstring
Minimum length 1.SpaceIdstringTypestring
ItemsPerPageintegerLastPageNumberintegerNumberOfPagesintegerTotalResultsinteger
Example Response
{
"ItemType": "string",
"Items": [
{
"Description": "string",
"EnvironmentTags": [
"string"
],
"Id": "Environments-1",
"Name": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Type": "string"
}
],
"ItemsPerPage": 0,
"LastPageNumber": 0,
"NumberOfPages": 0,
"TotalResults": 0
}